



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>lxml简明教程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">lxml简明教程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 01:46:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文链接：<a href="http://yifei.me/note/464" rel="external nofollow noreferrer">http://yifei.me/note/464</a><br /><br />
最近要做下微信爬虫，之前写个小东西都是直接用正则提取数据就算了，如果需要更稳定的提取数据，还是使用 xpath 定位元素比较可靠。周末没事，从爬虫的角度研究了一下 python xml 相关的库。</p>
<p>Python 标准库中自带了 xml 模块，但是性能不够好，而且缺乏一些人性化的 API，相比之下，第三方库 lxml 是用 Cython 实现的，而且增加了很多实用的功能，可谓爬虫处理网页数据的一件利器。lxml 大部分功能都存在 <code>lxml.etree</code>中，所以下文都假定已经执行了</p>
<pre class="prettyprint linenums"><code>from lxml import etree<br />
</code></pre>
<h2>解析 XML 字符串</h2>
<p>网页下载下来以后是个字符串的形式，使用<code>etree.fromstring(str)</code>构造一个 <code>etree._ElementTree</code>对象，使用 <code>etree.tostring(t)</code>返回一个字符串</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; xml_string = '&lt;root&gt;&lt;foo id=&quot;foo-id&quot; class=&quot;foo zoo&quot;&gt;Foo&lt;/foo&gt;&lt;bar&gt;中文&lt;/bar&gt;&lt;baz&gt;&lt;/baz&gt;&lt;/root&gt;'<br />
&gt;&gt;&gt; root = etree.fromstring(xml_string.encode('utf-8')) # 最好传 byte string

&gt;&gt;&gt; etree.tostring(root)<br />
# 默认返回的是 byte string<br />
b'&lt;root&gt;root content&lt;foo id=&quot;foo-id&quot; class=&quot;foo zoo&quot;&gt;Foo&lt;/foo&gt;&lt;bar&gt;Bar&lt;/bar&gt;&lt;baz/&gt;&lt;/root&gt;'

&gt;&gt;&gt; print(etree.tostring(root, pretty_print=True).decode('utf-8'))<br />
#decode 一下变成 unicode<br />
&lt;root&gt;<br />
  &lt;foo id=&quot;foo-id&quot; class=&quot;foo zoo&quot;&gt;Foo&lt;/foo&gt;<br />
  &lt;bar&gt;Bar&lt;/bar&gt;<br />
  &lt;baz/&gt; # 注意这里没有子节点的 baz 节点被变成了自闭和的标签<br />
&lt;/root&gt;

&gt;&gt;&gt; type(root)<br />
&lt;class 'lxml.etree._Element'&gt;

# 可以看出 tostring 返回的是一个_Element类型的对象，也就是整个 xml 树的根节点<br />
</code></pre>
<h2>Element结构</h2>
<p><code>etree._Element</code> 是一个设计很精妙的结构，可以把他当做一个对象访问当前节点自身的文本节点，可以把他当做一个数组，元素就是他的子节点，可以把它当做一个字典，从而遍历他的属性</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; root.text<br />
'root content' # 注意只是 root 自身的文本，并不包含子节点的文本<br />
&gt;&gt;&gt; root.tag<br />
'root'<br />
&gt;&gt;&gt; root[0].tag<br />
'foo'<br />
&gt;&gt;&gt; foo = root[0]<br />
&gt;&gt;&gt; for attr, val in foo.items():<br />
...     print(attr, val)<br />
...<br />
id foo-id<br />
class foo zoo<br />
&gt;&gt;&gt; foo.get('id')<br />
'foo-id'<br />
&gt;&gt;&gt; foo.attrib<br />
{'class': 'foo zoo', 'id': 'foo-id'}<br />
</code></pre>
<h2>Element 和 ElementTree</h2>
<p>xml 是一个树形结构，lxml 使用<code>etree._Element</code>和 <code>etree._ElementTree</code>来分别代表树中的节点和树，<code>etree.ELement</code>和 <code>etree.ElementTree</code> 分别是两个工厂函数</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; t = root.getroottree()<br />
# 获得一个节点对应的树<br />
&lt;lxml.etree._ElementTree object at 0x107295308&gt;

&gt;&gt;&gt; t.getroot() == root<br />
# 使用getroot 返回一个树的根节点<br />
True

&gt;&gt;&gt; foo_tree = etree.ElementTree(root)<br />
# 也可以从一个节点构造一个树，那么这个节点就是这棵树的根<br />
&gt;&gt;&gt; foo_tree.getroot().tag<br />
'foo'

&gt;&gt;&gt; foo.getroottree().tag<br />
'root'<br />
#注意，foo 这个节点的 roottree 仍然是以 root 节点为根的<br />
</code></pre>
<p>其他方法如<code>getparent()/getprevious()/getnext()</code>都是显而易见的，不赘述了</p>
<h2>XPath</h2>
<p>XPath 实在太强大了，在定位元素方面绝对是秒杀 CSS 选择器。在 lxml 中，<code>_Element</code>和 <code>_ElementTree</code> 分别具有xpath 函数，两者的区别在于：</p>
<p>如果是相对路径，<code>_Element.xpath</code>是以当前节点为参考的，<code>_ElementTree.xpath</code>以根为参考<br /><br />
如果是绝对路径，<code>_ElementTree.xpath</code>是以当前节点的<code>getroottree</code>的根节点为参考的</p>
<p>还有，如果 xpaht 表达式应该返回元素的话，总是返回一个数组，即使只有一个元素</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; foo.xpath('/root')[0].tag<br />
'root'<br />
&gt;&gt;&gt; foo.xpath('.')[0].tag<br />
'foo'<br />
&gt;&gt;&gt;<br />
&gt;&gt;&gt; t.xpath('/root')[0].tag<br />
'root'<br />
&gt;&gt;&gt; t.xpath('.')[0].tag<br />
'root'<br />
&gt;&gt;&gt;<br />
</code></pre>
<p>lxml 还支持几个函数 <code>find/findall</code>，他们使用 ElementPath，是一种类似 xpath 的语言，感觉很是奇怪，lxml 的文档描述他是 xpath 的一个子集，暂时不看了。</p>
<h2>HTML</h2>
<p>最后再来讨论一下 HTML，以上的讨论都是基于 xml 的，HTML 和 xml 还是有些许不同的，lxml 也有一个专门的 html 模块。<br /><br />
比如我们解析 html 的话最好使用<code>html.fromstring()</code>，返回的是<code>lxml.html.HtmlElement</code>，具有上述的所有能力，同时能够更好地兼容 html。</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; etree.fromstring('&lt;meta charset=utf-8 /&gt;')<br />
# 比如这句就会报错，因为属性值没有用引号括起来<br />
Traceback (most recent call last):<br />
  File &quot;&lt;stdin&gt;&quot;, line 1, in &lt;module&gt;<br />
  File &quot;src/lxml/lxml.etree.pyx&quot;, line 3213, in lxml.etree.fromstring (src/lxml/lxml.etree.c:77737)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 1830, in lxml.etree._parseMemoryDocument (src/lxml/lxml.etree.c:116674)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 1711, in lxml.etree._parseDoc (src/lxml/lxml.etree.c:115220)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 1051, in lxml.etree._BaseParser._parseUnicodeDoc (src/lxml/lxml.etree.c:109345)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 584, in lxml.etree._ParserContext._handleParseResultDoc (src/lxml/lxml.etree.c:103584)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 694, in lxml.etree._handleParseResult (src/lxml/lxml.etree.c:105238)<br />
  File &quot;src/lxml/parser.pxi&quot;, line 624, in lxml.etree._raiseParseError (src/lxml/lxml.etree.c:104147)<br />
lxml.etree.XMLSyntaxError: AttValue: &quot; or ' expected, line 1, column 15

&gt;&gt;&gt; html.fromstring('&lt;meta charset=utf-8&gt;')<br />
# 没有问题<br />
</code></pre>
<p><code>html.HtmlElement</code>同时多了几项功能</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; doc = html.fromstring('&lt;div&gt;&lt;p&gt;lorem &lt;span&gt;poium&lt;/span&gt;&lt;/p&gt;&lt;/div&gt;')

&gt;&gt;&gt; doc.text_content()<br />
'lorem poium'</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1jgn2q.html">Log4J日志管理类使用详解 &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwxo3l9.html">GIT之旅【第一篇】</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r355d9.html">Python学习笔记（迭代、模块扩展、GUI 、编码处理等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyjl1q.html">使用C&num; WinForm制作 员工打卡项目 -- S2 2&period;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z02zvq.html">ReactiveCocoa中信号的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kwvlj8.html">xml 解析  java  基础复习</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935v5rq.html">1&period;7 逆序数与归并排序&lbrack;inversion pairs by merge sort&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z54jv8.html">nginx安全相关设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxn4r9.html">onTouch事件试验（覆写onTouchEvent方法，同时设置onTouchListener）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedvmj9.html">effective c&plus;&plus; （二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j272l8.html">java 二叉树实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6rwg8.html">Spring Security 入门（1-1）Spring Security是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj67kj8.html">&lbrack;LeetCode&rsqb; Decode Ways II 解码方法之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmkgz8.html">Scipy教程 - 距离计算库scipy&period;spatial&period;distance</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jzrpv8.html">ios键盘弹起 body的高度拉长，页面底部空白问题。ios软键盘将页面抵到上面后，关闭软键盘页面不回弹的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd15pd9.html">IIS网站 由http协议改变为https协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605pyj9.html">微信小程序-动态设置背景色navigationBarBackgroundColor的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjl4ge9.html">初识kbmmw 5 中httpsys的支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnv6dgq.html">Linux下查找指定日期的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/963y4rj9.html">base和this</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwj0n138.html">Linux命令语句秘籍</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gedree8.html">How to set up Tensorflow inception-v3 model on Windows</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzpxzg8.html">volatile关键字和synchronized关键字</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mepz2rq.html">混合拉普拉斯分布（LMM）推导及实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1rx4dq.html">PDCA循环原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzpg708.html">webpack学习笔记（二）-- 初学者常见问题及解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zn36k9.html">linux性能监控分析及通过nmon&lowbar;analyse生成分析报表</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj5k438.html">iOS 如何保持线程一直在运转&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpo32jq.html">使用MyBatis对数据库中表实现CRUD操作（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj5rk69.html">Dubbo的配置及使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
